<template>
  <AppAbstractPage
    :breadcrumbs="breadcrumbs"
    class="PPKPart">
    <div slot="heading">
      <h1 class="heading _h1">
        {{ title }}
      </h1>
    </div>

    <div slot="content">
      <div class="content overflow__hidden">
        <div
          class="content-btn-mobile mobilshow"
          v-show="hasOptions">
          <AppButton
            v-if="displayMobile === 'info'"
            class="gray"
            :class="{ main: isMainPage }"
            @click.native="setDisplay('categories')">
            <span
              slot="button-item"
              class="button-item">
              <template v-if="isMainPage">Все категории</template>
              <template v-else>Категории</template>
            </span>
          </AppButton>
          <AppButton
            v-show="!isMainPage"
            v-if="displayMobile === 'categories'"
            class="gray"
            @click.native="setDisplay('info')">
            <span
              slot="button-item"
              class="button-item">
              Запчасти
            </span>
          </AppButton>
          <AppButton
            v-show="!isMainPage"
            v-if="displayMobile != 'filter'"
            class="_blue"
            @click.native="setDisplay('filter')">
            <span
              slot="button-item"
              class="button-item">
              Фильтры
            </span>
          </AppButton>
        </div>

        <div
          class="content-nav"
          :class="{ active: displayMobile === 'categories' }">
          <PartsCategories
            :active-item="urlParamsData"
            :parts-categories="partsCategories"
            @close="setDisplay('info')"/>
        </div>

        <div class="content-table">
          <NavAdditional
            v-if="additionalNav.length"
            :list-nav="additionalNav"
            :base-url="$route.path"
            :columns="$route.params.partName ? 6 : 4"/>

          <InfoNoResult
            v-if="hasNoResult"
            :part-name="urlParamsData.partName"
            :part-manufacturer="urlParamsData.partManufacturer"
            :no-offers="!count"
            :location="targetLocation"
            class="block noresult"
            :class="{ active: displayMobile === 'info'}"/>

          <h2
            v-if="hasSubtitle"
            class="block subtitle"
            :class="{ active: displayMobile === 'info'}">
            {{ title }} в других городах
          </h2>

          <div
            v-if="count && filtersValues"
            class="block filters "
            :class="{ active: displayMobile === 'filter' }">
            <filters
              v-model="filtersModel"
              :list="filtersValues"
              :fields="filtersFields"
              @apply="applyFilters"
              @close="setDisplay('info')"/>
          </div>

          <GridCategories
            v-if="isMainPage"
            :categories="partsCategories"/>

          <div
            v-else-if="count"
            class="block result"
            :class="{ active: displayMobile === 'info' }">
            <ResultTable
              :list="list"
              @show-applicability="showApplicabilityModal"
              v-model="order"/>
          </div>

          <div
            v-show="!isMainPage"
            class="block more"
            :class="{ active: displayMobile === 'info' }">
            <div
              v-if="count"
              class="count">
              &nbsp;Показано {{ countShown | spacifyNumber }} из {{ count | spacifyNumber }}
            </div>
            <AppButton
              class="buttonAsLink"
              v-if="lazyLoadEnabled"
              @click.native="showMore()">
              <span
                slot="button-item"
                class="button-item">
                Показать ещё
              </span>
            </AppButton>
          </div>

          <div
            v-if="seoInfo && seoInfo.content"
            v-html="seoInfo.content"
            class="block description"
            :class="{ active: displayMobile === 'info' }"/>
        </div>

      </div>
      <PartApplicability
        :show-content="{desktop: 'modal', mobile: 'modal'}"
        v-model="applicabilityModal.visible"
        :entities="applicabilityModal.list"
        :structure="$options.applicability"/>
    </div>
  </AppAbstractPage>
</template>

<script>
import {
  find,
  keys,
  union,
  get,
  mapValues,
  pickBy,
  isNil,
} from 'lodash-es';
import AppAbstractPage from '~/components/redesign/layout/app-abstract-page';
import PartsCategories from '~/components/redesign/PPK/parts-categories';
import NavAdditional from '~/components/redesign/PPK/nav-additional';
import InfoNoResult from '~/components/redesign/PPK/info-noresult';
import Filters from '~/components/redesign/PPK/filters';
import GridCategories from '~/components/redesign/PPK/grid-categories';
import ResultTable from '~/components/redesign/PPK/result-table';
import AppButton from '~/components/redesign/app-buttons/app-button';
import PartApplicability from '~/components/redesign/part-applicability';

// Structures
import { applicabilityExpert } from '~/assets/js/mocks/table/headings';

import SeoMixin from '~/assets/js/mixins/seo/base';
import SeoPageMixin from '~/assets/js/mixins/seo/pages/main/categories';

// TODO: Вынести в model
const initialFiltersModel = Object.freeze({
  city: null,
  partManufacturer: null,
  carManufacturer: null,
  partName: null,
  vendorCode: null,
});

export default {
  name: 'PPKPart',
  components: {
    PartApplicability,
    AppAbstractPage,
    PartsCategories,
    NavAdditional,
    InfoNoResult,
    Filters,
    GridCategories,
    ResultTable,
    AppButton,
  },
  mixins: [SeoMixin, SeoPageMixin],
  /*
   * @return {
   *   limit,
   *   offset,
   *   order,
   *   list,
   *   count,
   *   filtersValues,
   *   partsCategories,
   *   urlParamsData,
   *   targetLocation,
   *   noResultInUserCity,
   *   seoInfo,
   * }
   */
  async asyncData({
    app,
    params,
    error,
    store,
    route,
  }) {
    try {
      const { data: asyncData } = await app.$axios.$get('/_main/partCategories/getAsyncData', {
        params: {
          ...params,
          locationId: store.state.location.id,
          url: route.path,
        },
      });

      return asyncData;
    } catch (e) {
      if (get(e, 'response.data.error.errorCode', false) === 404) {
        error({ statusCode: 404 });
      } else {
        error({ statusCode: 500 });
      }
    }
    return {};
  },
  data() {
    return {
      apiCriteriaList: {},
      loading: {
        data: false,
        filters: false,
      },
      displayMobile: 'info',
      filtersModel: initialFiltersModel,
      applicabilityModal: {
        visible: false,
        list: [],
      },
      hasOptions: true,
    };
  },
  computed: {
    title() {
      const title = [];

      if (this.urlParamsData.partManufacturer && this.urlParamsData.partManufacturer.brand) {
        title.push(get(this.breadcrumbs[this.breadcrumbs.length - 2], 'name', ''));
        title.push(this.urlParamsData.partManufacturer.brand);
      } else {
        title.push(get(this.breadcrumbs[this.breadcrumbs.length - 1], 'name', ''));
      }

      return title.join(' ');
    },
    breadcrumbs() {
      const breadcrumbs = [
        {
          url: '',
          name: 'Каталоги',
        },
        {
          url: '/categories',
          name: 'Каталог товаров',
        },
      ];
      this.$route.params.group && breadcrumbs.push({
        url: `${breadcrumbs[1].url}/${this.urlParamsData.group.slug}`,
        name: this.urlParamsData.group.name,
      });

      this.$route.params.subgroup && breadcrumbs.push({
        url: `${breadcrumbs[2].url}/${this.urlParamsData.subgroup.slug}`,
        name: this.urlParamsData.subgroup.name,
      },);

      this.$route.params.partName && breadcrumbs.push({
        // eslint-disable-next-line
        url: `${breadcrumbs[3].url}/${this.urlParamsData.partName.slug}`,
        name: this.urlParamsData.partName.name,
      });

      this.$route.params.partManufacturer && breadcrumbs.push({
        url: `${breadcrumbs[4].url}/${this.urlParamsData.partManufacturer.slug}`,
        name: this.urlParamsData.partManufacturer.brand,
      });

      breadcrumbs[breadcrumbs.length - 1].url = '';

      console.log(breadcrumbs);

      return breadcrumbs;
    },
    filtersFields() {
      const filtersFields = {
        carManufacturer: true,
      };

      if (!this.$route.params.partManufacturer) {
        filtersFields.partManufacturer = true;
      }

      if (!this.$route.params.partName) {
        filtersFields.partName = true;
      } else {
        filtersFields.partId = true;
      }

      return filtersFields;
    },
    additionalNav() {
      if (!this.$route.params.group) {
        return [];
      }
      if (!this.$route.params.subgroup) {
        return this.urlParamsData.group.groupsList;
      }
      if (!this.$route.params.partName) {
        return this.urlParamsData.subgroup.groupsList;
      }
      if (!this.$route.params.partManufacturer) {
        return this.urlParamsData.partName.groupsList;
      }
      return [];
    },
    isMainPage() {
      return !this.urlParamsData.group || !this.urlParamsData.group.id;
    },
    hasSubtitle() {
      return this.urlParamsData.partName && this.noResultInUserCity && this.count;
    },
    hasNoResult() {
      return this.urlParamsData.partName && (!this.count || this.noResultInUserCity);
    },
    countShown() {
      return this.lazyLoadEnabled ? this.limit + this.offset : this.count;
    },
    lazyLoadEnabled() {
      return this.count > this.limit && (this.limit + this.offset) < this.count;
    },
    unboundFiltersModel() {
      return { ...this.filtersModel };
    },
  },
  watch: {
    async order() {
      await this.loadNewData();
    },
    unboundFiltersModel: {
      async handler(newValue, oldValue) {
        const unionKeys = union(keys(newValue), keys(oldValue));
        const changedFilterName = find(unionKeys, key => newValue[key] !== oldValue[key]);
        const changedFilterSavedValues = this.filtersValues[changedFilterName];
        await this.loadNewFilters();
        if (Array.isArray(changedFilterSavedValues) && changedFilterSavedValues.length > 1) {
          this.filtersValues[changedFilterName] = changedFilterSavedValues;
        }
      },
      deep: true,
    },
  },
  created() {
    this.apiCriteriaList = this.getApiCriteria();
    this.$options.applicability = applicabilityExpert;
  },
  methods: {
    async fetchData() {
      if (this.loading.data) {
        return false;
      }

      try {
        this.loading.data = true;
        const { data: { list, count } } = await this.$axios.$get('/_main/partCategories/getPartGridList', {
          params: {
            limit: this.limit,
            offset: this.offset,
            order: this.order,
            ...this.apiCriteriaList,
          },
        });
        return { list, count };
      } catch (e) {
        console.error(e);
        this.$error({ statusCode: 500 });
      } finally {
        this.loading.data = false;
      }
      return {};
    },
    async loadNewData() {
      this.offset = 0;
      const { list, count } = { ...await this.fetchData() };
      this.list = list;
      this.count = count;
      return true;
    },
    async showMore() {
      if (!this.lazyLoadEnabled) {
        return false;
      }
      this.offset += this.limit;
      const { list } = { ...await this.fetchData() };
      this.list = this.list.concat(list);
      return true;
    },
    async loadNewFilters() {
      if (this.loading.filters) {
        return false;
      }
      try {
        this.loading.filters = true;
        const { data } = await this.$axios.$get('/_main/partCategories/getPartGridFilters', {
          params: this.getApiCriteria(this.filtersModel),
        });
        this.filtersValues = data;
      } catch (e) {
        console.error(e);
        this.$nuxt.error({ statusCode: 500 });
      } finally {
        this.loading.filters = false;
      }
      return true;
    },
    getApiCriteria(filtersModel) {
      return {
        group: get(this.urlParamsData, 'group.id', ''),
        subgroup: get(this.urlParamsData, 'subgroup.id', ''),
        partName: get(this.urlParamsData, 'partName.id', ''),
        partManufacturer: get(this.urlParamsData, 'partManufacturer.id', ''),
        city: this.$store.state.location.id,
        ...mapValues(
          pickBy(filtersModel, model => !isNil(model)),
          value => Number(value.id),
        ),
      };
    },
    async applyFilters() {
      this.apiCriteriaList = this.getApiCriteria(this.filtersModel);
      await this.loadNewData();
    },
    showApplicabilityModal(data) {
      this.applicabilityModal.list = data;
      this.applicabilityModal.visible = true;
    },
    setDisplay(value) {
      this.displayMobile = value;
      this.hasOptions = !this.hasOptions;
    },
  },
};
</script>

<style lang="postcss">
  .PPKPart {
    .content {
      display: flex;
      flex-direction: row;
      flex-wrap: wrap;
      justify-content: flex-start;
      align-items: flex-start;
      height: auto;
      width: 100%;
      @media screen and (max-width: 980px) {
        flex-direction: column;
        height: 100%;
        flex: 1 0 100%;
      }
      @media screen and (min-width: 981px) {
        padding-bottom: 2rem;
      }
      .content-btn-mobile {
        display: block;
        width: 100%;
        padding: 0 1.5rem 1rem 1.5rem;
        .button {
          min-width: 8rem;
        }
        .button.gray {
          background-color: #ededed;
          border: 1px solid #c5d1d9;
          &:hover {
            background-color: #e5eaf5;
          }
          &.main {
            width: 100%;
            margin-right: 0;
          }
        }

        /*@media screen and (min-width: 1200px) {
          display: none;
        }*/
      }
      .content-nav {
        margin-bottom: 20rem;
        position: relative;
        z-index: 1;
        @media screen and (max-width: 980px) {
          width: 100%;
          flex: 1 0 auto;
          background-color: #ffffff;
          &:not(.active) {
            display: none;
          }
        }
        @media (min-width: 981px) and (max-width: 1199px) {
          width: 12.5rem;
          flex: 0 1 12.5rem;
        }
        @media screen and (min-width: 1200px) {
          width: 13rem;
          flex: 0 1 13rem;
        }
      }
      .content-table {
        @media screen and (max-width: 980px) {
          display: flex;
          flex-direction: column;
          flex: 1 0 100%;
          width: 100%;
        }
        @media (min-width: 981px) and (max-width: 1199px) {
          display: block;
          width: calc(100% - 12.5rem);
          padding-left: 1rem;
        }
        @media screen and (min-width: 1200px) {
          display: block;
          width: calc(100% - 13rem);
          padding-left: 1rem;
        }

        .block.result, .block.filters {
          display: flex;
          flex-direction: column;
          flex-wrap: nowrap;
          justify-content: flex-start;
          align-items: flex-start;
          height: 100%;
          width: 100%;
          flex: 1 0 100%;
        }
        > .block:not(.active) {
          @media screen and (max-width: 980px) {
            display: none;
          }
        }

        > .block.subtitle {
          width: 100%;
          margin: 0;
          padding: 1.5rem 0;
          font-size: 1rem;
          font-weight: 500;
          @media screen and (max-width: 980px) {
            padding-top: 0;
            font-size: 1.125rem;
          }
        }
        > .block.noresult {
          margin: 1.5rem 0;
        }
      }
      .block.more {
        display: flex;
        justify-content: center;
        align-items: center;
        width: 100%;

        .count {
          text-align: center;
          display: block;
          padding: 0 1rem;
          font-weight: 400;
          line-height: 1.3;
        }
        @media only screen and (min-width: 981px) {
          flex-flow: row nowrap;
          margin: 3rem 0 1rem;

          .count {
            font-size: 0.8125rem;
          }
        }
        @media only screen and (max-width: 980px) {
          &:not(.active) {
            display: none;
          }
          flex-flow: column-reverse nowrap;
          width: 100%;
          padding: 0;
          margin: 1rem 0 2rem 0;
          .count {
            font-size: 0.8125rem;
            padding-bottom: 1rem;
          }
        }
      }
      .block.call-filter {
        width: 100%;
        align-items: center;
        position: sticky;
        bottom: 0;
        padding-bottom: 2rem;
        .svg {
          display: inline-block;
          vertical-align: middle;
          padding: 0 0.25rem 0.25rem 0;
          width: auto;
          height: 1.25rem;
          fill: #1b1c1d;
        }
      }
      .block.description {
        display: block;
        width: 100%;
        padding: 2rem 0;
        font-size: 0.8125rem;
        line-height: 1.3;
        p {
          margin: 0;
          padding: 1rem 0 0 0;
        }
        ol, ul {
          margin: 0;
        }
        ul {
          margin-left: 1.5rem;
          list-style: disc;
        }
        @media screen and (max-width: 980px) {
          font-size: 1rem;
          padding: 0 1rem;
        }
      }
    }
    .overflow__hidden {
      overflow: hidden;
    }
  }
</style>
